
Temperature_32sensor_interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;Temperature sensor.mbas,47 :: 		sub procedure interrupt
;Temperature sensor.mbas,49 :: 		if tmr1_interrupt then
	BTFSS      PIR1+0, 0
	GOTO       L_Temperature_32sensor_interrupt2
;Temperature sensor.mbas,51 :: 		tmr1_interrupt = 0
	BCF        PIR1+0, 0
;Temperature sensor.mbas,55 :: 		if (count_tmr1 = delay_cicle) then
	MOVF       _count_tmr1+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_Temperature_32sensor_interrupt5
;Temperature sensor.mbas,57 :: 		tmr1h = 0
	CLRF       TMR1H+0
;Temperature sensor.mbas,58 :: 		tmr1l = 0
	CLRF       TMR1L+0
;Temperature sensor.mbas,60 :: 		count_tmr1 = 0
	CLRF       _count_tmr1+0
;Temperature sensor.mbas,61 :: 		conversion_complete.0 = 1
	BSF        _conversion_complete+0, 0
	GOTO       L_Temperature_32sensor_interrupt6
;Temperature sensor.mbas,62 :: 		else 'altrimenti incremento count_tmr1
L_Temperature_32sensor_interrupt5:
;Temperature sensor.mbas,63 :: 		count_tmr1 = count_tmr1 + 1
	INCF       _count_tmr1+0, 1
;Temperature sensor.mbas,64 :: 		end if
L_Temperature_32sensor_interrupt6:
L_Temperature_32sensor_interrupt2:
;Temperature sensor.mbas,65 :: 		end if
L_Temperature_32sensor_interrupt149:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of Temperature_32sensor_interrupt

Temperature_32sensor_send_data:

;Temperature sensor.mbas,68 :: 		sub procedure send_data(dim byref datasend as string[11])
;Temperature sensor.mbas,69 :: 		last_send_data = datasend
	MOVLW      _last_send_data+0
	MOVWF      FSR
	MOVF       FARG_send_data_datasend+0, 0
	MOVWF      R1+0
	CALL       ___CS2S+0
	CLRF       INDF+0
;Temperature sensor.mbas,70 :: 		led_activity = 1 'attiva led per segnalare invio
	BSF        PORTB+0, 7
;Temperature sensor.mbas,71 :: 		delay_ms(10)'Attende il rilascio del bus
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_Temperature_32sensor_send_data8:
	DECFSZ     R13+0, 1
	GOTO       L_Temperature_32sensor_send_data8
	DECFSZ     R12+0, 1
	GOTO       L_Temperature_32sensor_send_data8
	NOP
	NOP
;Temperature sensor.mbas,72 :: 		tx_uart_enable = 1 'abilita invio seriale
	BSF        TXSTA+0, 5
;Temperature sensor.mbas,73 :: 		RS485_bus_direction = 1 'seleziona la direzione di comunicazione
	BSF        PORTB+0, 3
;Temperature sensor.mbas,74 :: 		delay_us(400) 'attende attivazione MAX485
	MOVLW      133
	MOVWF      R13+0
L_Temperature_32sensor_send_data9:
	DECFSZ     R13+0, 1
	GOTO       L_Temperature_32sensor_send_data9
;Temperature sensor.mbas,75 :: 		UART1_Write_Text(datasend) 'invia la stringa generata
	MOVF       FARG_send_data_datasend+0, 0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	CALL       _UART1_Write_Text+0
;Temperature sensor.mbas,76 :: 		delay_ms(2) 'attende invio dei segnali
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_Temperature_32sensor_send_data10:
	DECFSZ     R13+0, 1
	GOTO       L_Temperature_32sensor_send_data10
	DECFSZ     R12+0, 1
	GOTO       L_Temperature_32sensor_send_data10
	NOP
	NOP
;Temperature sensor.mbas,77 :: 		led_activity = 0 'disattiva led attivit
	BCF        PORTB+0, 7
;Temperature sensor.mbas,78 :: 		RS485_bus_direction = 0 'seleziona la direzione di comunicazione (in ascolto)
	BCF        PORTB+0, 3
;Temperature sensor.mbas,79 :: 		tx_uart_enable = 0 'disabilita invio seriale
	BCF        TXSTA+0, 5
	RETURN
; end of Temperature_32sensor_send_data

Temperature_32sensor_code_data_to_send:

;Temperature sensor.mbas,92 :: 		dim address_slave_send as byte
;Temperature sensor.mbas,94 :: 		type_to_send = type_s * 4
	MOVF       FARG_code_data_to_send_type_s+0, 0
	MOVWF      code_data_to_send_type_to_send+0
	RLF        code_data_to_send_type_to_send+0, 1
	BCF        code_data_to_send_type_to_send+0, 0
	RLF        code_data_to_send_type_to_send+0, 1
	BCF        code_data_to_send_type_to_send+0, 0
;Temperature sensor.mbas,96 :: 		if (address_master_send <> 255) then
	MOVF       FARG_code_data_to_send_address_master_send+0, 0
	XORLW      255
	BTFSC      STATUS+0, 2
	GOTO       L_Temperature_32sensor_code_data_to_send13
;Temperature sensor.mbas,97 :: 		address_slave_send = adr_s
	MOVF       _adr_s+0, 0
	MOVWF      code_data_to_send_address_slave_send+0
	GOTO       L_Temperature_32sensor_code_data_to_send14
;Temperature sensor.mbas,98 :: 		else
L_Temperature_32sensor_code_data_to_send13:
;Temperature sensor.mbas,99 :: 		address_slave_send = 255
	MOVLW      255
	MOVWF      code_data_to_send_address_slave_send+0
;Temperature sensor.mbas,100 :: 		end if
L_Temperature_32sensor_code_data_to_send14:
;Temperature sensor.mbas,102 :: 		if (data1_s = 0) then
	MOVF       FARG_code_data_to_send_data1_s+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_Temperature_32sensor_code_data_to_send16
;Temperature sensor.mbas,103 :: 		data_send_1 = 48
	MOVLW      48
	MOVWF      code_data_to_send_data_send_1+0
;Temperature sensor.mbas,104 :: 		type_to_send.0 = 1
	BSF        code_data_to_send_type_to_send+0, 0
	GOTO       L_Temperature_32sensor_code_data_to_send17
;Temperature sensor.mbas,105 :: 		else
L_Temperature_32sensor_code_data_to_send16:
;Temperature sensor.mbas,106 :: 		data_send_1 = data1_s
	MOVF       FARG_code_data_to_send_data1_s+0, 0
	MOVWF      code_data_to_send_data_send_1+0
;Temperature sensor.mbas,107 :: 		end if
L_Temperature_32sensor_code_data_to_send17:
;Temperature sensor.mbas,108 :: 		if (data2_s = 0) then
	MOVF       FARG_code_data_to_send_data2_s+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_Temperature_32sensor_code_data_to_send19
;Temperature sensor.mbas,109 :: 		data_send_2 = 48
	MOVLW      48
	MOVWF      code_data_to_send_data_send_2+0
;Temperature sensor.mbas,110 :: 		type_to_send.1 = 1
	BSF        code_data_to_send_type_to_send+0, 1
	GOTO       L_Temperature_32sensor_code_data_to_send20
;Temperature sensor.mbas,111 :: 		else
L_Temperature_32sensor_code_data_to_send19:
;Temperature sensor.mbas,112 :: 		data_send_2 = data2_s
	MOVF       FARG_code_data_to_send_data2_s+0, 0
	MOVWF      code_data_to_send_data_send_2+0
;Temperature sensor.mbas,113 :: 		end if
L_Temperature_32sensor_code_data_to_send20:
;Temperature sensor.mbas,115 :: 		checksum_send = address_master_send xor address_slave_send xor type_to_send xor data_send_1 xor data_send_2
	MOVF       code_data_to_send_address_slave_send+0, 0
	XORWF      FARG_code_data_to_send_address_master_send+0, 0
	MOVWF      R0+0
	MOVF       code_data_to_send_type_to_send+0, 0
	XORWF      R0+0, 1
	MOVF       code_data_to_send_data_send_1+0, 0
	XORWF      R0+0, 1
	MOVF       code_data_to_send_data_send_2+0, 0
	XORWF      R0+0, 0
	MOVWF      R1+0
;Temperature sensor.mbas,116 :: 		checksum_send_low = (checksum_send and 15) or 128
	MOVLW      15
	ANDWF      R1+0, 0
	MOVWF      _string_compose+6
	BSF        _string_compose+6, 7
;Temperature sensor.mbas,117 :: 		checksum_send_hi =  (checksum_send / 16) or 128
	MOVF       R1+0, 0
	MOVWF      _string_compose+7
	RRF        _string_compose+7, 1
	BCF        _string_compose+7, 7
	RRF        _string_compose+7, 1
	BCF        _string_compose+7, 7
	RRF        _string_compose+7, 1
	BCF        _string_compose+7, 7
	RRF        _string_compose+7, 1
	BCF        _string_compose+7, 7
	BSF        _string_compose+7, 7
;Temperature sensor.mbas,119 :: 		string_compose[0] = "S"
	MOVLW      83
	MOVWF      _string_compose+0
;Temperature sensor.mbas,120 :: 		string_compose[1] = address_master_send
	MOVF       FARG_code_data_to_send_address_master_send+0, 0
	MOVWF      _string_compose+1
;Temperature sensor.mbas,121 :: 		string_compose[2] = address_slave_send
	MOVF       code_data_to_send_address_slave_send+0, 0
	MOVWF      _string_compose+2
;Temperature sensor.mbas,122 :: 		string_compose[3] = type_to_send
	MOVF       code_data_to_send_type_to_send+0, 0
	MOVWF      _string_compose+3
;Temperature sensor.mbas,123 :: 		string_compose[4] = data_send_1
	MOVF       code_data_to_send_data_send_1+0, 0
	MOVWF      _string_compose+4
;Temperature sensor.mbas,124 :: 		string_compose[5] = data_send_2
	MOVF       code_data_to_send_data_send_2+0, 0
	MOVWF      _string_compose+5
;Temperature sensor.mbas,125 :: 		string_compose[6] = checksum_send_low
;Temperature sensor.mbas,126 :: 		string_compose[7] = checksum_send_hi
;Temperature sensor.mbas,127 :: 		string_compose[8] = 3
	MOVLW      3
	MOVWF      _string_compose+8
;Temperature sensor.mbas,128 :: 		string_compose[9] = 3
	MOVLW      3
	MOVWF      _string_compose+9
;Temperature sensor.mbas,129 :: 		string_compose[10] = 3
	MOVLW      3
	MOVWF      _string_compose+10
;Temperature sensor.mbas,130 :: 		string_compose[11] = 0
	CLRF       _string_compose+11
;Temperature sensor.mbas,131 :: 		send_data(string_compose)
	MOVLW      _string_compose+0
	MOVWF      FARG_send_data_datasend+0
	CALL       Temperature_32sensor_send_data+0
	RETURN
; end of Temperature_32sensor_code_data_to_send

Temperature_32sensor_decode_ric_data:

;Temperature sensor.mbas,142 :: 		dim calcolated_checksum as byte
;Temperature sensor.mbas,143 :: 		correct_data = 0
	MOVF       FARG_decode_ric_data_correct_data+0, 0
	MOVWF      FSR
	CLRF       INDF+0
;Temperature sensor.mbas,145 :: 		if (array_in_data[0] = 83) then 'se start byte  corretto
	MOVF       FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      83
	BTFSS      STATUS+0, 2
	GOTO       L_Temperature_32sensor_decode_ric_data23
;Temperature sensor.mbas,148 :: 		chk_low = array_in_data[6] and 15
	MOVLW      6
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVLW      15
	ANDWF      INDF+0, 0
	MOVWF      R3+0
;Temperature sensor.mbas,149 :: 		chk_hi = array_in_data[7] and 15
	MOVLW      7
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVLW      15
	ANDWF      INDF+0, 0
	MOVWF      R2+0
;Temperature sensor.mbas,150 :: 		checksum = (chk_hi * 16) or chk_low 'mette insieme i 2 byte per ricostruire il byte di checksum
	MOVF       R2+0, 0
	MOVWF      R0+0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	MOVF       R0+0, 0
	IORWF      R3+0, 1
;Temperature sensor.mbas,152 :: 		calcolated_checksum = array_in_data[1] xor array_in_data[2] xor array_in_data[3] xor array_in_data[4] xor array_in_data[5]
	INCF       FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      R1+0
	MOVLW      2
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R0+0
	MOVF       R1+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORWF      R0+0, 1
	MOVLW      3
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORWF      R0+0, 1
	MOVLW      4
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORWF      R0+0, 1
	MOVLW      5
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORWF      R0+0, 1
;Temperature sensor.mbas,153 :: 		if (calcolated_checksum = checksum) and (array_in_data[6].7 = 1) and (array_in_data[7].7 = 1) then 'se il checksum  corretto
	MOVF       R0+0, 0
	XORWF      R3+0, 0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R2+0
	MOVLW      6
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      R1+0
	CLRF       R0+0
	MOVF       R1+0, 0
	MOVWF      FSR
	BTFSS      INDF+0, 7
	GOTO       L_Temperature_32sensor_decode_ric_data28
	MOVLW      255
	MOVWF      R0+0
L_Temperature_32sensor_decode_ric_data28:
	MOVF       R0+0, 0
	ANDWF      R2+0, 1
	MOVLW      7
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      R1+0
	CLRF       R0+0
	MOVF       R1+0, 0
	MOVWF      FSR
	BTFSS      INDF+0, 7
	GOTO       L_Temperature_32sensor_decode_ric_data29
	MOVLW      255
	MOVWF      R0+0
L_Temperature_32sensor_decode_ric_data29:
	MOVF       R2+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L_Temperature_32sensor_decode_ric_data26
;Temperature sensor.mbas,154 :: 		address_ric = array_in_data[1]
	INCF       FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R0+0
	MOVF       FARG_decode_ric_data_address_ric+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;Temperature sensor.mbas,155 :: 		address_master = array_in_data[2]
	MOVLW      2
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R0+0
	MOVF       FARG_decode_ric_data_address_master+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;Temperature sensor.mbas,156 :: 		type_ric = (array_in_data[3] and 252)/4 'preleva il byte che seleziona il tipo di chiamata
	MOVLW      3
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVLW      252
	ANDWF      INDF+0, 0
	MOVWF      R2+0
	MOVF       R2+0, 0
	MOVWF      R0+0
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	MOVF       FARG_decode_ric_data_type_ric+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;Temperature sensor.mbas,158 :: 		if (array_in_data[4] = 48) and (array_in_data[3].0 = 1) then 'se data1  uguale a zero (controllo zero flag 1)
	MOVLW      4
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      48
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R2+0
	MOVLW      3
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      R1+0
	CLRF       R0+0
	MOVF       R1+0, 0
	MOVWF      FSR
	BTFSS      INDF+0, 0
	GOTO       L_Temperature_32sensor_decode_ric_data33
	MOVLW      255
	MOVWF      R0+0
L_Temperature_32sensor_decode_ric_data33:
	MOVF       R2+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L_Temperature_32sensor_decode_ric_data31
;Temperature sensor.mbas,159 :: 		data1_ric = 0
	MOVF       FARG_decode_ric_data_data1_ric+0, 0
	MOVWF      FSR
	CLRF       INDF+0
	GOTO       L_Temperature_32sensor_decode_ric_data32
;Temperature sensor.mbas,160 :: 		else 'altrimenti viene copiato il byte
L_Temperature_32sensor_decode_ric_data31:
;Temperature sensor.mbas,161 :: 		data1_ric = array_in_data[4]
	MOVLW      4
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R0+0
	MOVF       FARG_decode_ric_data_data1_ric+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;Temperature sensor.mbas,162 :: 		end if
L_Temperature_32sensor_decode_ric_data32:
;Temperature sensor.mbas,163 :: 		if (array_in_data[5] = 48) and (array_in_data[3].1 = 1) then 'se data2  uguale a zero (controllo zero flag 2)
	MOVLW      5
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      48
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R2+0
	MOVLW      3
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      R1+0
	CLRF       R0+0
	MOVF       R1+0, 0
	MOVWF      FSR
	BTFSS      INDF+0, 1
	GOTO       L_Temperature_32sensor_decode_ric_data37
	MOVLW      255
	MOVWF      R0+0
L_Temperature_32sensor_decode_ric_data37:
	MOVF       R2+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L_Temperature_32sensor_decode_ric_data35
;Temperature sensor.mbas,164 :: 		data2_ric = 0
	MOVF       FARG_decode_ric_data_data2_ric+0, 0
	MOVWF      FSR
	CLRF       INDF+0
	GOTO       L_Temperature_32sensor_decode_ric_data36
;Temperature sensor.mbas,165 :: 		else 'altrimenti viene copiato il byte
L_Temperature_32sensor_decode_ric_data35:
;Temperature sensor.mbas,166 :: 		data2_ric = array_in_data[5]
	MOVLW      5
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R0+0
	MOVF       FARG_decode_ric_data_data2_ric+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;Temperature sensor.mbas,167 :: 		end if
L_Temperature_32sensor_decode_ric_data36:
;Temperature sensor.mbas,169 :: 		correct_data = 1
	MOVF       FARG_decode_ric_data_correct_data+0, 0
	MOVWF      FSR
	MOVLW      1
	MOVWF      INDF+0
L_Temperature_32sensor_decode_ric_data26:
;Temperature sensor.mbas,170 :: 		end if
L_Temperature_32sensor_decode_ric_data23:
;Temperature sensor.mbas,171 :: 		end if
	RETURN
; end of Temperature_32sensor_decode_ric_data

Temperature_32sensor_start_conversion_temp:

;Temperature sensor.mbas,175 :: 		sub procedure start_conversion_temp()
;Temperature sensor.mbas,177 :: 		sensor_present = Ow_Reset(port_sensor, sensor_pin)
	MOVLW      PORTA+0
	MOVWF      FARG_Ow_Reset_port+0
	MOVLW      4
	MOVWF      FARG_Ow_Reset_pin+0
	CALL       _Ow_Reset+0
	MOVF       R0+0, 0
	MOVWF      _sensor_present+0
;Temperature sensor.mbas,179 :: 		sensor_present = not sensor_present 'inverto sato logico
	COMF       R0+0, 0
	MOVWF      _sensor_present+0
;Temperature sensor.mbas,181 :: 		Ow_Write(port_sensor, sensor_pin, 0xCC)
	MOVLW      PORTA+0
	MOVWF      FARG_Ow_Write_port+0
	MOVLW      4
	MOVWF      FARG_Ow_Write_pin+0
	MOVLW      204
	MOVWF      FARG_Ow_Write_data_+0
	CALL       _Ow_Write+0
;Temperature sensor.mbas,182 :: 		Ow_Write(port_sensor, sensor_pin, 0x44)
	MOVLW      PORTA+0
	MOVWF      FARG_Ow_Write_port+0
	MOVLW      4
	MOVWF      FARG_Ow_Write_pin+0
	MOVLW      68
	MOVWF      FARG_Ow_Write_data_+0
	CALL       _Ow_Write+0
;Temperature sensor.mbas,184 :: 		if sensor_present.0 then
	BTFSS      _sensor_present+0, 0
	GOTO       L_Temperature_32sensor_start_conversion_temp40
;Temperature sensor.mbas,186 :: 		tmr1h = 0
	CLRF       TMR1H+0
;Temperature sensor.mbas,187 :: 		tmr1l = 0
	CLRF       TMR1L+0
;Temperature sensor.mbas,188 :: 		count_tmr1 = 0
	CLRF       _count_tmr1+0
;Temperature sensor.mbas,190 :: 		tmr1_enable = 1
	BSF        T1CON+0, 0
L_Temperature_32sensor_start_conversion_temp40:
;Temperature sensor.mbas,191 :: 		end if
	RETURN
; end of Temperature_32sensor_start_conversion_temp

Temperature_32sensor_read_temp:

;Temperature sensor.mbas,195 :: 		sub procedure read_temp()
;Temperature sensor.mbas,197 :: 		Ow_Reset(port_sensor, sensor_pin)
	MOVLW      PORTA+0
	MOVWF      FARG_Ow_Reset_port+0
	MOVLW      4
	MOVWF      FARG_Ow_Reset_pin+0
	CALL       _Ow_Reset+0
;Temperature sensor.mbas,199 :: 		Ow_Write(port_sensor, sensor_pin, 0xCC)
	MOVLW      PORTA+0
	MOVWF      FARG_Ow_Write_port+0
	MOVLW      4
	MOVWF      FARG_Ow_Write_pin+0
	MOVLW      204
	MOVWF      FARG_Ow_Write_data_+0
	CALL       _Ow_Write+0
;Temperature sensor.mbas,200 :: 		Ow_Write(port_sensor, sensor_pin, 0xBE)
	MOVLW      PORTA+0
	MOVWF      FARG_Ow_Write_port+0
	MOVLW      4
	MOVWF      FARG_Ow_Write_pin+0
	MOVLW      190
	MOVWF      FARG_Ow_Write_data_+0
	CALL       _Ow_Write+0
;Temperature sensor.mbas,202 :: 		temp_byte_1  = Ow_Read(port_sensor, sensor_pin)
	MOVLW      PORTA+0
	MOVWF      FARG_Ow_Read_port+0
	MOVLW      4
	MOVWF      FARG_Ow_Read_pin+0
	CALL       _Ow_Read+0
	MOVF       R0+0, 0
	MOVWF      _temp_byte_1+0
;Temperature sensor.mbas,203 :: 		temp_byte_2 = Ow_Read(port_sensor, sensor_pin)
	MOVLW      PORTA+0
	MOVWF      FARG_Ow_Read_port+0
	MOVLW      4
	MOVWF      FARG_Ow_Read_pin+0
	CALL       _Ow_Read+0
	MOVF       R0+0, 0
	MOVWF      _temp_byte_2+0
;Temperature sensor.mbas,205 :: 		tmr1_enable = 0
	BCF        T1CON+0, 0
	RETURN
; end of Temperature_32sensor_read_temp

_main:

;Temperature sensor.mbas,209 :: 		main: 'inizio programma
;Temperature sensor.mbas,210 :: 		cmcon = $07 'disabilito modulo CCP
	MOVLW      7
	MOVWF      CMCON+0
;Temperature sensor.mbas,211 :: 		trisa = $FF 'configura gli i/o di porta (bin 11111111)
	MOVLW      255
	MOVWF      TRISA+0
;Temperature sensor.mbas,212 :: 		trisb = $73 'configura gli i/o di portb (bin 01110011)
	MOVLW      115
	MOVWF      TRISB+0
;Temperature sensor.mbas,213 :: 		porta = 0 'reset delle porte
	CLRF       PORTA+0
;Temperature sensor.mbas,214 :: 		portb = 0
	CLRF       PORTB+0
;Temperature sensor.mbas,217 :: 		INTCON = $C0
	MOVLW      192
	MOVWF      INTCON+0
;Temperature sensor.mbas,218 :: 		PIE1 = $01
	MOVLW      1
	MOVWF      PIE1+0
;Temperature sensor.mbas,219 :: 		PIR1 = $00
	CLRF       PIR1+0
;Temperature sensor.mbas,220 :: 		T1CON = $34
	MOVLW      52
	MOVWF      T1CON+0
;Temperature sensor.mbas,223 :: 		tmr1_enable = 0
	BCF        T1CON+0, 0
;Temperature sensor.mbas,224 :: 		tmr1h = 0
	CLRF       TMR1H+0
;Temperature sensor.mbas,225 :: 		tmr1l = 0
	CLRF       TMR1L+0
;Temperature sensor.mbas,226 :: 		count_tmr1 = 0
	CLRF       _count_tmr1+0
;Temperature sensor.mbas,227 :: 		conversion_complete = 0
	CLRF       _conversion_complete+0
;Temperature sensor.mbas,229 :: 		uart1_init(9600) 'inizializzazione uart hardware pic a 9600 bps
	MOVLW      25
	MOVWF      SPBRG+0
	BSF        TXSTA+0, 2
	CALL       _UART1_Init+0
;Temperature sensor.mbas,230 :: 		tx_uart_enable = 0 'disabilita invio seriale
	BCF        TXSTA+0, 5
;Temperature sensor.mbas,231 :: 		rx_uart_enable = 0 'diabilita ricezione seriale
	BCF        RCSTA+0, 4
;Temperature sensor.mbas,232 :: 		adr_m = EEPROM_Read($00) 'Prelievo degli indirizzi dalla EEPROM
	CLRF       FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	MOVWF      _adr_m+0
;Temperature sensor.mbas,233 :: 		adr_s = EEPROM_Read($01)
	MOVLW      1
	MOVWF      FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	MOVWF      _adr_s+0
;Temperature sensor.mbas,236 :: 		led_activity = 1 'attivo led
	BSF        PORTB+0, 7
;Temperature sensor.mbas,238 :: 		start_conversion_temp() 'effettuo una lettura di temperatura
	CALL       Temperature_32sensor_start_conversion_temp+0
;Temperature sensor.mbas,239 :: 		delay_ms(750)'Attendo conversione
	MOVLW      4
	MOVWF      R11+0
	MOVLW      207
	MOVWF      R12+0
	MOVLW      1
	MOVWF      R13+0
L__main44:
	DECFSZ     R13+0, 1
	GOTO       L__main44
	DECFSZ     R12+0, 1
	GOTO       L__main44
	DECFSZ     R11+0, 1
	GOTO       L__main44
	NOP
	NOP
;Temperature sensor.mbas,240 :: 		if (sensor_present.0 = 1) then 'se il sensore  presente disattivo led
	BTFSS      _sensor_present+0, 0
	GOTO       L__main46
;Temperature sensor.mbas,241 :: 		led_activity = 0
	BCF        PORTB+0, 7
L__main46:
;Temperature sensor.mbas,244 :: 		get_data_received = "" 'azzero dato ricezione
	CLRF       _get_data_received+0
;Temperature sensor.mbas,245 :: 		read_request = 0 'azzera la richiesta di lettura
	CLRF       _read_request+0
;Temperature sensor.mbas,246 :: 		rx_uart_enable = 1  'abilito ricezione seriale
	BSF        RCSTA+0, 4
;Temperature sensor.mbas,249 :: 		while true
L__main49:
;Temperature sensor.mbas,250 :: 		clrwdt 'resetto watchdog timer
	CLRWDT
;Temperature sensor.mbas,251 :: 		if conversion_complete.0 then
	BTFSS      _conversion_complete+0, 0
	GOTO       L__main54
;Temperature sensor.mbas,252 :: 		conversion_complete.0 = 0
	BCF        _conversion_complete+0, 0
;Temperature sensor.mbas,253 :: 		read_temp()
	CALL       Temperature_32sensor_read_temp+0
L__main54:
;Temperature sensor.mbas,255 :: 		if (UART1_Data_Ready() = 1)  then
	CALL       _UART1_Data_Ready+0
	MOVF       R0+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main57
;Temperature sensor.mbas,256 :: 		UART1_Read_Text(get_data_received, "", 11) 'la trama termina con 3 byte 3
	MOVLW      _get_data_received+0
	MOVWF      FARG_UART1_Read_Text_Output+0
	MOVLW      3
	MOVWF      _main_Local_Text+0
	MOVLW      3
	MOVWF      _main_Local_Text+1
	MOVLW      3
	MOVWF      _main_Local_Text+2
	CLRF       _main_Local_Text+3
	MOVLW      _main_Local_Text+0
	MOVWF      FARG_UART1_Read_Text_Delimiter+0
	MOVLW      11
	MOVWF      FARG_UART1_Read_Text_Attempts+0
	CALL       _UART1_Read_Text+0
;Temperature sensor.mbas,257 :: 		rx_uart_enable = 0 'disabilita ricezione UART
	BCF        RCSTA+0, 4
;Temperature sensor.mbas,258 :: 		delay_ms(2) 'attende 2ms prima di far partire la procedura
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L__main59:
	DECFSZ     R13+0, 1
	GOTO       L__main59
	DECFSZ     R12+0, 1
	GOTO       L__main59
	NOP
	NOP
;Temperature sensor.mbas,259 :: 		decode_ric_data(get_data_received, correct_packet, address_packet, adr_sender_test, type_packet, data1_packet, data2_packet)
	MOVLW      _get_data_received+0
	MOVWF      FARG_decode_ric_data_array_in_data+0
	MOVLW      _correct_packet+0
	MOVWF      FARG_decode_ric_data_correct_data+0
	MOVLW      _address_packet+0
	MOVWF      FARG_decode_ric_data_address_ric+0
	MOVLW      _adr_sender_test+0
	MOVWF      FARG_decode_ric_data_address_master+0
	MOVLW      _type_packet+0
	MOVWF      FARG_decode_ric_data_type_ric+0
	MOVLW      _data1_packet+0
	MOVWF      FARG_decode_ric_data_data1_ric+0
	MOVLW      _data2_packet+0
	MOVWF      FARG_decode_ric_data_data2_ric+0
	CALL       Temperature_32sensor_decode_ric_data+0
;Temperature sensor.mbas,260 :: 		if (correct_packet = 1) then 'risposnde solo se il pacchetto  corretto ed inviato dal master
	MOVF       _correct_packet+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main61
;Temperature sensor.mbas,261 :: 		if (adr_s = address_packet) and (adr_sender_test = adr_m) and (program_button = 0) then
	MOVF       _adr_s+0, 0
	XORWF      _address_packet+0, 0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _adr_sender_test+0, 0
	XORWF      _adr_m+0, 0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 1
	CLRF       R0+0
	BTFSC      PORTB+0, 5
	GOTO       L__main66
	MOVLW      255
	MOVWF      R0+0
L__main66:
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main64
;Temperature sensor.mbas,263 :: 		case 1
	MOVF       _type_packet+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main70
;Temperature sensor.mbas,264 :: 		if (data1_packet = 63) and (data2_packet = 0) then
	MOVF       _data1_packet+0, 0
	XORLW      63
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _data2_packet+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main72
;Temperature sensor.mbas,265 :: 		code_data_to_send(adr_m,1,33,device_type)
	MOVF       _adr_m+0, 0
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      1
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVLW      33
	MOVWF      FARG_code_data_to_send_data1_s+0
	MOVLW      84
	MOVWF      FARG_code_data_to_send_data2_s+0
	CALL       Temperature_32sensor_code_data_to_send+0
L__main72:
;Temperature sensor.mbas,266 :: 		end if
	GOTO       L__main67
L__main70:
;Temperature sensor.mbas,269 :: 		case 20
	MOVF       _type_packet+0, 0
	XORLW      20
	BTFSS      STATUS+0, 2
	GOTO       L__main76
;Temperature sensor.mbas,270 :: 		if (data1_packet = 63) and (data2_packet = 0) then
	MOVF       _data1_packet+0, 0
	XORLW      63
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _data2_packet+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main78
;Temperature sensor.mbas,271 :: 		if sensor_present.0 then 'se rileva il sensore
	BTFSS      _sensor_present+0, 0
	GOTO       L__main81
;Temperature sensor.mbas,273 :: 		if (tmr1_enable = 0) then
	BTFSC      T1CON+0, 0
	GOTO       L__main84
;Temperature sensor.mbas,274 :: 		start_conversion_temp() 'chiama la funzione di lettura temperatura
	CALL       Temperature_32sensor_start_conversion_temp+0
;Temperature sensor.mbas,275 :: 		code_data_to_send(adr_m,20,83,0)
	MOVF       _adr_m+0, 0
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      20
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVLW      83
	MOVWF      FARG_code_data_to_send_data1_s+0
	CLRF       FARG_code_data_to_send_data2_s+0
	CALL       Temperature_32sensor_code_data_to_send+0
	GOTO       L__main85
;Temperature sensor.mbas,276 :: 		else 'se il timer  attivo (conversione in corso)
L__main84:
;Temperature sensor.mbas,277 :: 		code_data_to_send(adr_m,63,5,0) 'Invio errore conversione ancora in corso
	MOVF       _adr_m+0, 0
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      63
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVLW      5
	MOVWF      FARG_code_data_to_send_data1_s+0
	CLRF       FARG_code_data_to_send_data2_s+0
	CALL       Temperature_32sensor_code_data_to_send+0
;Temperature sensor.mbas,278 :: 		end if
L__main85:
	GOTO       L__main82
;Temperature sensor.mbas,279 :: 		else
L__main81:
;Temperature sensor.mbas,280 :: 		code_data_to_send(adr_m,63,4,0)'invio errore sensore temperatura non rilevato
	MOVF       _adr_m+0, 0
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      63
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVLW      4
	MOVWF      FARG_code_data_to_send_data1_s+0
	CLRF       FARG_code_data_to_send_data2_s+0
	CALL       Temperature_32sensor_code_data_to_send+0
;Temperature sensor.mbas,281 :: 		end if
L__main82:
;Temperature sensor.mbas,283 :: 		read_request.0 = 0
	BCF        _read_request+0, 0
L__main78:
;Temperature sensor.mbas,284 :: 		end if
	GOTO       L__main67
L__main76:
;Temperature sensor.mbas,287 :: 		case 21
	MOVF       _type_packet+0, 0
	XORLW      21
	BTFSS      STATUS+0, 2
	GOTO       L__main88
;Temperature sensor.mbas,288 :: 		if (data1_packet = 63) and (data2_packet = 0) then
	MOVF       _data1_packet+0, 0
	XORLW      63
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _data2_packet+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main90
;Temperature sensor.mbas,289 :: 		if read_request.0 and sensor_present.0 then 'Verifica se  la prima richiesta di lettura
	BTFSS      _read_request+0, 0
	GOTO       L__main150
	BTFSS      _sensor_present+0, 0
	GOTO       L__main150
	BSF        3, 0
	GOTO       L__main151
L__main150:
	BCF        3, 0
L__main151:
	BTFSS      3, 0
	GOTO       L__main93
;Temperature sensor.mbas,292 :: 		if (tmr1_enable = 0) then
	BTFSC      T1CON+0, 0
	GOTO       L__main96
;Temperature sensor.mbas,293 :: 		code_data_to_send(adr_m,21,temp_byte_1,temp_byte_2)
	MOVF       _adr_m+0, 0
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      21
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVF       _temp_byte_1+0, 0
	MOVWF      FARG_code_data_to_send_data1_s+0
	MOVF       _temp_byte_2+0, 0
	MOVWF      FARG_code_data_to_send_data2_s+0
	CALL       Temperature_32sensor_code_data_to_send+0
;Temperature sensor.mbas,294 :: 		read_request.0 = 0 'resetto registro prima lettura
	BCF        _read_request+0, 0
	GOTO       L__main97
;Temperature sensor.mbas,295 :: 		else 'se il timer  attivo (conversione in corso)
L__main96:
;Temperature sensor.mbas,296 :: 		code_data_to_send(adr_m,63,5,0) 'Invio errore conversione ancora in corso
	MOVF       _adr_m+0, 0
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      63
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVLW      5
	MOVWF      FARG_code_data_to_send_data1_s+0
	CLRF       FARG_code_data_to_send_data2_s+0
	CALL       Temperature_32sensor_code_data_to_send+0
;Temperature sensor.mbas,297 :: 		end if
L__main97:
	GOTO       L__main94
;Temperature sensor.mbas,298 :: 		else 'altrimenti
L__main93:
;Temperature sensor.mbas,299 :: 		if sensor_present.0 then 'se il sensore  presente
	BTFSS      _sensor_present+0, 0
	GOTO       L__main99
;Temperature sensor.mbas,300 :: 		code_data_to_send(adr_m,63,3,0) 'invia codice errore lettura senza richiesta (errore 3)
	MOVF       _adr_m+0, 0
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      63
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVLW      3
	MOVWF      FARG_code_data_to_send_data1_s+0
	CLRF       FARG_code_data_to_send_data2_s+0
	CALL       Temperature_32sensor_code_data_to_send+0
	GOTO       L__main100
;Temperature sensor.mbas,301 :: 		else
L__main99:
;Temperature sensor.mbas,302 :: 		code_data_to_send(adr_m,63,4,0)'invio errore sensore temperatura non rilevato
	MOVF       _adr_m+0, 0
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      63
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVLW      4
	MOVWF      FARG_code_data_to_send_data1_s+0
	CLRF       FARG_code_data_to_send_data2_s+0
	CALL       Temperature_32sensor_code_data_to_send+0
;Temperature sensor.mbas,303 :: 		end if
L__main100:
;Temperature sensor.mbas,304 :: 		end if
L__main94:
L__main90:
;Temperature sensor.mbas,305 :: 		end if
	GOTO       L__main67
L__main88:
;Temperature sensor.mbas,308 :: 		case 22
	MOVF       _type_packet+0, 0
	XORLW      22
	BTFSS      STATUS+0, 2
	GOTO       L__main103
;Temperature sensor.mbas,309 :: 		if (data1_packet = 63) and (data2_packet = 0) then
	MOVF       _data1_packet+0, 0
	XORLW      63
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _data2_packet+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main105
;Temperature sensor.mbas,310 :: 		if sensor_present.0 then
	BTFSS      _sensor_present+0, 0
	GOTO       L__main108
;Temperature sensor.mbas,311 :: 		if (tmr1_enable = 0) then
	BTFSC      T1CON+0, 0
	GOTO       L__main111
;Temperature sensor.mbas,312 :: 		code_data_to_send(adr_m,22,temp_byte_1,temp_byte_2)
	MOVF       _adr_m+0, 0
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      22
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVF       _temp_byte_1+0, 0
	MOVWF      FARG_code_data_to_send_data1_s+0
	MOVF       _temp_byte_2+0, 0
	MOVWF      FARG_code_data_to_send_data2_s+0
	CALL       Temperature_32sensor_code_data_to_send+0
	GOTO       L__main112
;Temperature sensor.mbas,313 :: 		else 'se il timer  attivo (conversione in corso)
L__main111:
;Temperature sensor.mbas,314 :: 		code_data_to_send(adr_m,63,5,0) 'Invio errore conversione ancora in corso
	MOVF       _adr_m+0, 0
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      63
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVLW      5
	MOVWF      FARG_code_data_to_send_data1_s+0
	CLRF       FARG_code_data_to_send_data2_s+0
	CALL       Temperature_32sensor_code_data_to_send+0
;Temperature sensor.mbas,315 :: 		end if
L__main112:
	GOTO       L__main109
;Temperature sensor.mbas,316 :: 		else
L__main108:
;Temperature sensor.mbas,317 :: 		code_data_to_send(adr_m,63,4,0)'invio errore sensore temperatura non rilevato
	MOVF       _adr_m+0, 0
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      63
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVLW      4
	MOVWF      FARG_code_data_to_send_data1_s+0
	CLRF       FARG_code_data_to_send_data2_s+0
	CALL       Temperature_32sensor_code_data_to_send+0
;Temperature sensor.mbas,318 :: 		end if
L__main109:
L__main105:
;Temperature sensor.mbas,319 :: 		end if
	GOTO       L__main67
L__main103:
;Temperature sensor.mbas,321 :: 		case 63 'ricevuto codice errore
	MOVF       _type_packet+0, 0
	XORLW      63
	BTFSS      STATUS+0, 2
	GOTO       L__main115
;Temperature sensor.mbas,322 :: 		if (data1_packet = 2) and (data2_packet = 0) then 'se l'invio precedente era errato (errore 2)
	MOVF       _data1_packet+0, 0
	XORLW      2
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _data2_packet+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main117
;Temperature sensor.mbas,323 :: 		send_data(last_send_data) 'reinvia l'ultimo dato
	MOVLW      _last_send_data+0
	MOVWF      FARG_send_data_datasend+0
	CALL       Temperature_32sensor_send_data+0
L__main117:
;Temperature sensor.mbas,324 :: 		end if
	GOTO       L__main67
L__main115:
L__main67:
;Temperature sensor.mbas,326 :: 		end select
	GOTO       L__main65
;Temperature sensor.mbas,327 :: 		else 'se gli indirizzi non sono di uso normale
L__main64:
;Temperature sensor.mbas,328 :: 		if (address_packet = 255) and (adr_sender_test = 255) then 'indirizzo che richiama tutti i dispositivi
	MOVF       _address_packet+0, 0
	XORLW      255
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _adr_sender_test+0, 0
	XORLW      255
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main120
;Temperature sensor.mbas,332 :: 		case 60
	MOVF       _type_packet+0, 0
	XORLW      60
	BTFSS      STATUS+0, 2
	GOTO       L__main125
;Temperature sensor.mbas,333 :: 		if (program_button = 1) then 'solo se il selettore  im modalit programmazione parte la procedura
	BTFSS      PORTB+0, 5
	GOTO       L__main127
;Temperature sensor.mbas,334 :: 		if (data1_packet <> 0) and (data2_packet <> 0) and (data1_packet < 255) and
	MOVF       _data1_packet+0, 0
	XORLW      0
	MOVLW      255
	BTFSC      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _data2_packet+0, 0
	XORLW      0
	MOVLW      255
	BTFSC      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 1
	MOVLW      255
	SUBWF      _data1_packet+0, 0
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 1
;Temperature sensor.mbas,335 :: 		(data2_packet < 255) and (data1_packet <> data2_packet) then
	MOVLW      255
	SUBWF      _data2_packet+0, 0
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 1
	MOVF       _data1_packet+0, 0
	XORWF      _data2_packet+0, 0
	MOVLW      255
	BTFSC      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main130
;Temperature sensor.mbas,336 :: 		EEPROM_Write($00, data1_packet) 'scrivo i nuovi indirizzi in EEPROM
	CLRF       FARG_EEPROM_Write_address+0
	MOVF       _data1_packet+0, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;Temperature sensor.mbas,337 :: 		EEPROM_Write($01, data2_packet)
	MOVLW      1
	MOVWF      FARG_EEPROM_Write_address+0
	MOVF       _data2_packet+0, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;Temperature sensor.mbas,338 :: 		code_data_to_send(255,60,65,79) 'invia pacchetto programmazione corretta
	MOVLW      255
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      60
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVLW      65
	MOVWF      FARG_code_data_to_send_data1_s+0
	MOVLW      79
	MOVWF      FARG_code_data_to_send_data2_s+0
	CALL       Temperature_32sensor_code_data_to_send+0
;Temperature sensor.mbas,339 :: 		led_activity = 1
	BSF        PORTB+0, 7
;Temperature sensor.mbas,340 :: 		delay_ms(1000)
	MOVLW      6
	MOVWF      R11+0
	MOVLW      19
	MOVWF      R12+0
	MOVLW      173
	MOVWF      R13+0
L__main132:
	DECFSZ     R13+0, 1
	GOTO       L__main132
	DECFSZ     R12+0, 1
	GOTO       L__main132
	DECFSZ     R11+0, 1
	GOTO       L__main132
	NOP
	NOP
;Temperature sensor.mbas,341 :: 		led_activity = 0
	BCF        PORTB+0, 7
	GOTO       L__main131
;Temperature sensor.mbas,342 :: 		else
L__main130:
;Temperature sensor.mbas,343 :: 		code_data_to_send(255,63,1,0) 'invia pacchetto programmazione errata (errore 1)
	MOVLW      255
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      63
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVLW      1
	MOVWF      FARG_code_data_to_send_data1_s+0
	CLRF       FARG_code_data_to_send_data2_s+0
	CALL       Temperature_32sensor_code_data_to_send+0
;Temperature sensor.mbas,344 :: 		led_activity = 1
	BSF        PORTB+0, 7
;Temperature sensor.mbas,345 :: 		delay_ms(50)
	MOVLW      65
	MOVWF      R12+0
	MOVLW      238
	MOVWF      R13+0
L__main133:
	DECFSZ     R13+0, 1
	GOTO       L__main133
	DECFSZ     R12+0, 1
	GOTO       L__main133
	NOP
;Temperature sensor.mbas,346 :: 		led_activity = 0
	BCF        PORTB+0, 7
;Temperature sensor.mbas,347 :: 		end if
L__main131:
L__main127:
;Temperature sensor.mbas,348 :: 		end if
	GOTO       L__main122
L__main125:
;Temperature sensor.mbas,351 :: 		case 50, 52
	MOVF       _type_packet+0, 0
	XORLW      50
	BTFSS      STATUS+0, 2
	GOTO       L__main136
	GOTO       L__main134
L__main136:
	MOVF       _type_packet+0, 0
	XORLW      52
	BTFSS      STATUS+0, 2
	GOTO       L__main137
L__main134:
;Temperature sensor.mbas,352 :: 		if (data1_packet = 63) and (data2_packet = 0) and (program_button = 0)  then
	MOVF       _data1_packet+0, 0
	XORLW      63
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _data2_packet+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 1
	CLRF       R0+0
	BTFSC      PORTB+0, 5
	GOTO       L__main141
	MOVLW      255
	MOVWF      R0+0
L__main141:
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main139
;Temperature sensor.mbas,353 :: 		if (tmr1_enable = 0) then 'solo se non gi chiamata fa partire la conversione
	BTFSC      T1CON+0, 0
	GOTO       L__main143
;Temperature sensor.mbas,354 :: 		start_conversion_temp() 'chiama la funzione di lettura temperatura
	CALL       Temperature_32sensor_start_conversion_temp+0
L__main143:
;Temperature sensor.mbas,356 :: 		if sensor_present.0 then 'se rileva il sensore
	BTFSS      _sensor_present+0, 0
	GOTO       L__main146
;Temperature sensor.mbas,357 :: 		read_request.0 = 1
	BSF        _read_request+0, 0
	GOTO       L__main147
;Temperature sensor.mbas,358 :: 		else 'altrimenti
L__main146:
;Temperature sensor.mbas,359 :: 		read_request.0 = 0
	BCF        _read_request+0, 0
;Temperature sensor.mbas,360 :: 		end if
L__main147:
;Temperature sensor.mbas,361 :: 		led_activity = 1  'Segnalo con l'attivazione del led l'attivit
	BSF        PORTB+0, 7
;Temperature sensor.mbas,362 :: 		delay_ms(20)
	MOVLW      26
	MOVWF      R12+0
	MOVLW      248
	MOVWF      R13+0
L__main148:
	DECFSZ     R13+0, 1
	GOTO       L__main148
	DECFSZ     R12+0, 1
	GOTO       L__main148
	NOP
;Temperature sensor.mbas,363 :: 		led_activity = 0
	BCF        PORTB+0, 7
L__main139:
;Temperature sensor.mbas,364 :: 		end if
	GOTO       L__main122
L__main137:
L__main122:
;Temperature sensor.mbas,366 :: 		end select
L__main120:
;Temperature sensor.mbas,368 :: 		end if
L__main65:
L__main61:
;Temperature sensor.mbas,370 :: 		get_data_received = "" 'Svuoto buffer ricezione
	CLRF       _get_data_received+0
;Temperature sensor.mbas,371 :: 		rx_uart_enable = 1 'Abilita ricezione UART
	BSF        RCSTA+0, 4
L__main57:
;Temperature sensor.mbas,373 :: 		wend
	GOTO       L__main49
	GOTO       $+0
; end of _main
